# Verify Signature OffChain

The "Verify Signature OffChain" capability in the KrypC wallet-dev Service API enables users to verify the authenticity of cryptographic signatures associated with transactions or messages off-chain. This feature enhances security by allowing users to confirm the validity of signatures without interacting directly with the blockchain, facilitating trust and integrity in decentralized systems.

This will allow to Verify Signature off chain.&#x20;

## API Specification

## Verify Signature OffChain API

<mark style="color:green;">`POST`</mark> `https://api.krypcore.com/api/v0/devWallet/verifySignatureOffChain`

To verify signature offchain API under the given instance.&#x20;

#### Headers

| Name                                            | Type   | Description            |
| ----------------------------------------------- | ------ | ---------------------- |
| DappId<mark style="color:red;">\*</mark>        | String | DappId                 |
| Authorization<mark style="color:red;">\*</mark> | String | User Auth key obtained |
| SubscriptionId                                  | String | SubscriptionId         |
| ChainId                                         | String | ChainId                |

#### Request Body

| Name                                         | Type   | Description |
| -------------------------------------------- | ------ | ----------- |
| privateKey<mark style="color:red;">\*</mark> | String | Private Key |
| message<mark style="color:red;">\*</mark>    | String | Message     |
| signature<mark style="color:red;">\*</mark>  | String | Signature   |

{% tabs %}
{% tab title="200: OK SUCCESS" %}

```javascript
{
    "Data": {
        "isVerified": true
    },
    "Message": "",
    "Status": "SUCCESS"
}
```

{% endtab %}

{% tab title="401: Unauthorized Failure in authentication" %}

```javascript
{
    "message": "Invalid API key in request"
}
```

{% endtab %}

{% tab title="500: Internal Server Error Key values should be given" %}

```
{
    "message": "Internal Server Error"
}
```

{% endtab %}
{% endtabs %}

Take a look at how you might call this method using our official libraries, or via `curl`

{% tabs %}
{% tab title="curl" %}

```bash

curl --location 'https://api.krypcore.com/api/v0/devWallet/verifySignatureOffChain' \
--header 'DappId: **********' \
--header 'Authorization: **********' \
--header 'SubscriptionId: ********' \
--header 'ChainId: ********' \
--header 'Content-Type: application/json' \
--data '{
    "privateKey": "**********",
    "message": "Hello",
    "signature": "**********"
}'
```

{% endtab %}

{% tab title="Node.js (Fetch)" %}

```javascript

var myHeaders = new Headers();
myHeaders.append("DappId", "**********");
myHeaders.append("Authorization", "**********");
myHeaders.append("SubscriptionId", "********");
myHeaders.append("ChainId", "********");
myHeaders.append("Content-Type", "application/json");

var raw = JSON.stringify({
  "privateKey": "**********",
  "message": "Hello",
  "signature": "**********"
});

var requestOptions = {
  method: 'POST',
  headers: myHeaders,
  body: raw,
  redirect: 'follow'
};

fetch("https://api.krypcore.com/api/v0/devWallet/verifySignatureOffChain", requestOptions)
  .then(response => response.text())
  .then(result => console.log(result))
  .catch(error => console.log('error', error));
```

{% endtab %}

{% tab title="Python " %}

```python

import requests
import json

url = "https://api.krypcore.com/api/v0/devWallet/verifySignatureOffChain"

payload = json.dumps({
  "privateKey": "**********",
  "message": "Hello",
  "signature": "**********"
})
headers = {
  'DappId': '**********',
  'Authorization': '**********',
  'SubscriptionId': '********',
  'ChainId': '********',
  'Content-Type': 'application/json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)

```

{% endtab %}

{% tab title="Golang" %}

```go

package main

import (
  "fmt"
  "strings"
  "net/http"
  "io/ioutil"
)

func main() {

  url := "https://api.krypcore.com/api/v0/devWallet/verifySignatureOffChain"
  method := "POST"

  payload := strings.NewReader(`{
    "privateKey": "**********",
    "message": "Hello",
    "signature": "**********"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("DappId", "**********")
  req.Header.Add("Authorization", "**********")
  req.Header.Add("SubscriptionId", "********")
  req.Header.Add("ChainId", "********")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := ioutil.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.krypcore.com/dev-docs/api-reference/core-service-apis/wallet-manager/developer-wallet/verify-signature-offchain.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
